<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="700"
        >
          <json-view :data="$data" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionModelo }}</strong>
    </div>
    <!--Contenido-->
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">{{ textoGestionModelo }}</div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <br />
      <v-stepper v-model="stepActive" :alt-labels="true">
        <v-stepper-header>
          <template v-for="(itemStep, indexItemStep) in steps">
            <v-stepper-step
              :key="`${indexItemStep}-step`"
              :complete="stepActive > indexItemStep"
              :step="itemStep.no"
              :rules="[() => !itemStep.isStepInvalid]"
            >
              <span :class="[{ 'error--text': itemStep.isStepInvalid }]">
                {{ itemStep.name }}
              </span>
            </v-stepper-step>
            <div
              class="v-divider progress"
              :key="indexItemStep"
              v-if="indexItemStep !== steps.length - 1"
            >
              <v-progress-linear
                :value="getProgressBar(indexItemStep)"
                :color="!itemStep.isStepInvalid ? 'primary' : 'error'"
                height="10"
                reactive
                striped
              ></v-progress-linear>
            </div>
          </template>
        </v-stepper-header>
        <v-stepper-items>
          <v-stepper-content
            v-for="(itemStep, indexItemStep) in steps"
            :key="indexItemStep + '-content'"
            :step="itemStep.no"
          >
            <div style="min-height: 540px">
              <template v-if="itemStep.no === 1">
                <GestionEjesModeloFranquicia
                  :ref="'stepper-content-' + indexItemStep"
                  :data="$data"
                />
              </template>
              <template v-if="itemStep.no === 2">
                <GestionDisciplinasEjesModeloFranquicia
                  :ref="'stepper-content-' + indexItemStep"
                  :data="$data"
                />
              </template>
              <template v-if="itemStep.no === 3">
                <GestionDisciplinasNegocioModelo
                  :ref="'stepper-content-' + indexItemStep"
                  :data="$data"
                />
              </template>
              <template v-if="itemStep.no === 4">
                <SummaryDisciplinasNegocioModelo
                  :ref="'stepper-content-' + indexItemStep"
                  :data="$data"
                />
              </template>
              <v-footer absolute>
                <div class="btnCenter ma-0">
                  <v-btn
                    :class="[{ desac: !(stepActive != 1) }]"
                    class="mr-6"
                    depressed
                    dark
                    tile
                    color="primary"
                    @click="previewStep"
                    >Regresar</v-btn
                  >
                  <v-btn
                    :class="[{ desac: stepActive === steps.length }]"
                    class="mr-6"
                    depressed
                    dark
                    tile
                    color="primary"
                    @click="nextStep"
                    >Continuar</v-btn
                  >
                </div>
              </v-footer>
            </div>
          </v-stepper-content>
        </v-stepper-items>
      </v-stepper>
      <div v-if="stepActive == steps.length" class="btnCenter">
        <v-btn
          class="mr-6"
          :class="[{ desac: !hasGlobalChanges }]"
          depressed
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          >Cancelar cambios</v-btn
        >
        <v-btn
          :class="[{ desac: !hasGlobalChanges }, { desac: savingModelo }]"
          depressed
          dark
          tile
          color="primary"
          @click="saveModelo"
          >Guardar cambios</v-btn
        >
      </div>
    </div>
    <template>
      <v-dialog
        v-model="dialogErrorValidationNombreModelo"
        persistent
        max-width="600px"
      >
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Ocurrio un error al validar el nombre del modelo
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidationNombreModelo = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que corregirlos para
            moverte entre un paso y otro.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSavingForBack" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Ooops!</strong>
            </div>
          </v-card-title>
          <v-card-text
            >¡Es necesario guardar tus cambios para poder regresar.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogSavingForBack = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
              <v-btn
                color="secondary"
                icon
                dark
                @click="dialogCancel = false"
                style="position: absolute;right: 0px;top: 0px;"
              >
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              Proceso correcto
            </div>
          </v-card-title>
          <v-card-text>
            ¡Se han
            <strong>guardado los cambios de manera exitosa!</strong>
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                :to="{
                  name: 'modelo_franquicia_franquicias_franquicia_modelo',
                  params: {
                    franquicia: serviceCommons.objectToBase64(this.franquicia)
                  }
                }"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Regresar a Modelos</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.v-divider.progress {
  border: none;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
import GestionEjesModeloFranquicia from "@/views/secure/modelo-franquicia/franquicias/modelos/components/GestionEjesModeloFranquicia.vue";
import GestionDisciplinasEjesModeloFranquicia from "@/views/secure/modelo-franquicia/franquicias/modelos/components/GestionDisciplinasEjesModeloFranquicia.vue";
import GestionDisciplinasNegocioModelo from "@/views/secure/modelo-franquicia/franquicias/modelos/components/GestionDisciplinasNegocioModelo.vue";
import SummaryDisciplinasNegocioModelo from "@/views/secure/modelo-franquicia/franquicias/modelos/components/SummaryDisciplinasNegocioModelo.vue";
import { required } from "vuelidate/lib/validators";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-GestionModeloFranquicia",
  components: {
    LeavePage,
    GestionEjesModeloFranquicia,
    GestionDisciplinasEjesModeloFranquicia,
    GestionDisciplinasNegocioModelo,
    SummaryDisciplinasNegocioModelo
  },
  data() {
    return {
      dialogErrorValidation: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidationNombreModelo: false,
      dialogSavingForBack: false,
      isUniqueModelo: true,
      savingModelo: false,
      stepActive: 1,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Franquicias",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_franquicias"
          }
        }
      ],
      steps: [
        {
          no: 1,
          name: "Modelo",
          isStepInvalid: false
        },
        {
          no: 2,
          name: "Disciplinas",
          isStepInvalid: false
        },
        {
          no: 3,
          name: "Vincular Medición",
          isStepInvalid: false
        },
        {
          no: 4,
          name: "Resumen",
          isStepInvalid: false
        }
      ],
      metadata: {},
      modelo: {
        nombre_modelo: "",
        id_franquicia: null,
        ejes_modelo: [],
        negocios_modelo: []
      },
      modeloBackup: {
        nombre_modelo: "",
        id_franquicia: null,
        ejes_modelo: [],
        negocios_modelo: []
      },
      textoGestionModelo: null
    };
  },
  validations: {
    steps: {
      $each: {
        isStepInvalid: {
          required: value => {
            return value !== null && !value;
          }
        }
      }
    }
  },
  watch: {
    modelo: {
      deep: true,
      handler: function(before) {
        delete before.updated;
        delete before.inserted;
        if (this.modeloBackup) {
          const modeloBackup = JSON.parse(JSON.stringify(this.modeloBackup));
          delete modeloBackup.ejes_modelo;
          const originalValue = JSON.stringify(modeloBackup).replace(/"/g, "");
          const current = JSON.parse(JSON.stringify(before));
          delete current.ejes_modelo;
          const currentValue = JSON.stringify(current).replace(/"/g, "");
          const hasGlobalChanges = originalValue !== currentValue;
          if (hasGlobalChanges) {
            if (before.id_modelo) {
              before.updated = true;
            } else {
              before.inserted = true;
            }
          }
        }
      }
    },
    "modelo.ejes_modelo": {
      deep: true,
      handler: function(before) {
        if (before) {
          before.forEach((itemEjeModelo, indexItemEjeModelo) => {
            delete itemEjeModelo.updated;
            if (!itemEjeModelo.inserted && !itemEjeModelo.deleted) {
              const modeloBackup = JSON.parse(
                JSON.stringify(this.modeloBackup)
              );
              const ejeModeloBackup =
                modeloBackup.ejes_modelo[indexItemEjeModelo];
              if (ejeModeloBackup) {
                delete ejeModeloBackup.disciplinas_eje;
                const originalValue = JSON.stringify(ejeModeloBackup).replace(
                  /"/g,
                  ""
                );

                const itemEjeModeloCurrent = JSON.parse(
                  JSON.stringify(itemEjeModelo)
                );

                delete itemEjeModeloCurrent.search_eje;
                delete itemEjeModeloCurrent.disciplinas_eje;

                const itemDisciplinasEjeModeloCurrent = JSON.parse(
                  JSON.stringify(itemEjeModelo)
                );

                const currentValue = JSON.stringify(
                  itemEjeModeloCurrent
                ).replace(/"/g, "");
                const hasGlobalChanges = originalValue !== currentValue;
                if (hasGlobalChanges) {
                  itemEjeModelo.updated = true;
                  if (itemEjeModelo.deleted) {
                    delete itemEjeModelo.updated;
                  }
                }
              }
            }
          });
          before.forEach((itemEjeModelo, indexItemEjeModelo) => {
            if (
              !itemEjeModelo.inserted &&
              !itemEjeModelo.deleted &&
              itemEjeModelo.disciplinas_eje
            ) {
              itemEjeModelo.disciplinas_eje.forEach(
                (itemDisciplinaEje, indexItemDisciplinaEje) => {
                  delete itemDisciplinaEje.updated;
                  if (
                    !itemDisciplinaEje.inserted &&
                    !itemDisciplinaEje.deleted
                  ) {
                    const modeloBackup = JSON.parse(
                      JSON.stringify(this.modeloBackup)
                    );
                    const disciplinaEjeModeloBackup =
                      modeloBackup.ejes_modelo[indexItemEjeModelo]
                        .disciplinas_eje[indexItemDisciplinaEje];
                    if (disciplinaEjeModeloBackup) {
                      const originalValue = JSON.stringify(
                        disciplinaEjeModeloBackup
                      ).replace(/"/g, "");

                      const disciplinaEjeCurrentValue = JSON.parse(
                        JSON.stringify(itemDisciplinaEje)
                      );

                      delete disciplinaEjeCurrentValue.no;
                      delete disciplinaEjeCurrentValue.search_disciplina;

                      const currentValue = JSON.stringify(
                        disciplinaEjeCurrentValue
                      ).replace(/"/g, "");

                      const hasGlobalChanges = originalValue !== currentValue;
                      if (hasGlobalChanges) {
                        itemDisciplinaEje.updated = true;
                        if (itemDisciplinaEje.deleted) {
                          delete itemDisciplinaEje.updated;
                        }
                      }
                    }
                  }
                }
              );
            }
          });
          if (this.modelo.negocios_modelo) {
            this.modelo.negocios_modelo.forEach(
              (itemNegocioModelo, indexItemNegocioModelo) => {
                let ejesModeloNegocio = itemNegocioModelo.ejes_modelo;
                if (ejesModeloNegocio) {
                  let ejesModeloTemp = [];
                  before.forEach((itemEjeModelo, indexItemEjeModelo) => {
                    let itemEjeModeloTemp = JSON.parse(
                      JSON.stringify(itemEjeModelo)
                    );
                    let disciplinasEje = itemEjeModeloTemp.disciplinas_eje;
                    if (disciplinasEje) {
                      let disciplinasEjeNegocioTemp = [];
                      disciplinasEje.forEach(
                        (itemDisciplinaEje, indexItemDisciplinaEje) => {
                          let disciplinasEjeNegocio =
                            ejesModeloNegocio[indexItemEjeModelo]
                              .disciplinas_eje_negocio;
                          if (disciplinasEjeNegocio) {
                            let disciplinaEjeNegocio =
                              disciplinasEjeNegocio[indexItemDisciplinaEje];
                            if (!disciplinaEjeNegocio) {
                              disciplinaEjeNegocio = {
                                id_disciplina_negocio: null,
                                protocolos: []
                              };
                            }
                            let disciplinaEje = {
                              id_disciplina: itemDisciplinaEje.id_disciplina
                            };
                            let disciplinaEjeNegocioMerged = {
                              ...disciplinaEjeNegocio,
                              ...disciplinaEje
                            };
                            disciplinasEjeNegocioTemp.push(
                              disciplinaEjeNegocioMerged
                            );
                          }
                        }
                      );
                      itemEjeModeloTemp.disciplinas_eje_negocio = disciplinasEjeNegocioTemp;
                      delete itemEjeModeloTemp.disciplinas_eje;
                    }
                    let ejeModeloNegocio = this.modelo.negocios_modelo[
                      indexItemNegocioModelo
                    ].ejes_modelo[indexItemEjeModelo];
                    if (!ejeModeloNegocio) {
                      ejeModeloNegocio = {
                        id_eje_modelo: null,
                        disciplinas_eje_negocio: []
                      };
                    }
                    let ejeModelo = {
                      id_eje: itemEjeModeloTemp.id_eje,
                      disciplinas_eje_negocio:
                        itemEjeModeloTemp.disciplinas_eje_negocio
                    };
                    let ejeModeloNegocioMerged = {
                      ...ejeModeloNegocio,
                      ...ejeModelo
                    };
                    ejesModeloTemp.push(ejeModeloNegocioMerged);
                  });
                  this.modelo.negocios_modelo[
                    indexItemNegocioModelo
                  ].ejes_modelo = ejesModeloTemp;
                }
              }
            );
          }
        }
      }
    }
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.modeloBackup) {
        const originalValue = JSON.stringify(this.modeloBackup).replace(
          /"/g,
          ""
        );
        const modelo = JSON.parse(JSON.stringify(this.modelo));
        modelo.ejes_modelo.forEach(itemEjeModelo => {
          delete itemEjeModelo.search_eje;
          if (itemEjeModelo.disciplinas_eje) {
            itemEjeModelo.disciplinas_eje.forEach(
              (itemDisciplinaEje, indexItemDisciplinaEje) => {
                delete itemDisciplinaEje.no;
                delete itemDisciplinaEje.search_disciplina;
              }
            );
          }
        });
        const currentValue = JSON.stringify(modelo).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.modelo.id_modelo === undefined;
      }
    }
  },
  methods: {
    initValues() {
      if (this.franquicia) {
        this.breadcrumbs.push({
          text: serviceCommons.titleCase(this.franquicia.descripcion),
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_franquicias_franquicia_modelo",
            params: {
              franquicia: serviceCommons.objectToBase64(this.franquicia)
            }
          }
        });
      }
      if (this.modelo.id_modelo) {
        this.breadcrumbs.push({
          text: "Edición",
          disabled: true
        });
        this.textoGestionModelo = "Editando un Modelo";
      } else {
        this.breadcrumbs.push({
          text: "Nuevo",
          disabled: true
        });
        this.textoGestionModelo = "Nuevo Modelo";
      }
    },
    async existModelo() {
      if (this.modeloBackup.nombre_modelo === this.modelo.nombre_modelo) {
        return await false;
      } else {
        const self = this;
        return await axios
          .get(
            "/modelo/secure/get/nombre?value=" +
              this.modelo.nombre_modelo +
              "&" +
              "idFranquicia=" +
              this.modelo.id_franquicia
          )
          .then(response => {
            if (response) {
              if (response.data.status_code === 200) {
                const exist =
                  (response.data.track_code &&
                    response.data.track_code === 3006) === undefined;
                if (exist) {
                  self.dialogErrorValidationNombreModelo = true;
                  self.isUniqueModelo = false;
                }
                return exist;
              } else {
                return false;
              }
            }
          })
          .catch(error => {
            console.log(error);
            return false;
          })
          .finally(function() {});
      }
    },
    getModelo() {
      var self = this;
      axios
        .get("/modelos/franquicia/secure/get/data/" + self.modelo.id_modelo)
        .then(response => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.metadata) {
                self.setMetadata(data.metadata);
              }
              if (data.modelo) {
                self.setModelo(data.modelo);
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    async saveModelo() {
      this.validateActiveStep();
      let indexStepActive = this.getIndexStepByNo(this.stepActive);
      let stepActive = this.steps[indexStepActive];
      if (!stepActive.isStepInvalid) {
        const self = this;
        this.modelo.id_empleado_modifica = user.empleado;
        if (!this.modelo.id_modelo) {
          this.modelo.id_empleado_crea = user.empleado;
        }
        const isModelo = await this.existModelo();
        if (!isModelo) {
          this.savingModelo = true;
          axios
            .post("/modelos/franquicia/secure/cud", this.modelo)
            .then(response => {
              if (response) {
                let data = response.data.data;
                if (response.data.status_code === 200) {
                  data.ejes_modelo = data.ejes_modelo.filter(itemEje => {
                    delete itemEje.inserted;
                    delete itemEje.updated;
                    if (itemEje.disciplinas_eje) {
                      itemEje.disciplinas_eje = itemEje.disciplinas_eje.filter(
                        itemDisciplinaEje => {
                          delete itemDisciplinaEje.inserted;
                          delete itemDisciplinaEje.updated;
                          return !itemDisciplinaEje.deleted;
                        }
                      );
                    }
                    return !itemEje.deleted;
                  });
                  delete data.inserted;
                  delete data.updated;
                  self.setModelo(data);
                  if (this.stepActive === this.steps.length) {
                    self.dialogSave = true;
                  }
                } else {
                  console.log("No Update");
                }
              }
            })
            .catch(error => {
              console.log(error);
            })
            .finally(function() {
              self.savingModelo = false;
            });
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    getDataModelo() {
      var self = this;
      axios
        .get(
          "/modelos/franquicia/secure/get/data/franquicia/" +
            this.modelo.id_franquicia
        )
        .then(response => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.metadata) {
                self.setMetadata(data.metadata);
              }
              if (data.modelo) {
                self.setModelo(data.modelo);
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    getIndexStepByNo(no) {
      let indexStepOut;
      this.steps.forEach((itemStep, indexItemStep) => {
        if (no == itemStep.no) {
          indexStepOut = indexItemStep;
        }
      });
      return indexStepOut;
    },
    setModelo(data) {
      if (data.negocios_modelo) {
        let gekNegocio;
        if (!data.id_franquicia) {
          data.id_franquicia = this.modelo.id_franquicia;
        }
        data.negocios_modelo = data.negocios_modelo.filter(
          itemNegocioModelo => {
            let negocio = this.getNegocioFromMetadata(
              itemNegocioModelo.id_negocio
            );
            if (negocio.descripcion.toLowerCase() === "gek") {
              gekNegocio = itemNegocioModelo;
            } else {
              return itemNegocioModelo;
            }
          }
        );
        if (gekNegocio) {
          data.negocios_modelo.push(gekNegocio);
        }
      }
      this.modelo = data;
      this.modeloBackup = JSON.parse(JSON.stringify(this.modelo));
    },
    setMetadata(data) {
      this.metadata = data;
    },
    previewStep() {
      if (this.stepActive === 1) {
        this.stepActive = 1;
      } else {
        this.stepActive = this.stepActive - 1;
      }
    },
    nextStep() {
      this.validateActiveStep();
      let indexStepActive = this.getIndexStepByNo(this.stepActive);
      let stepActive = this.steps[indexStepActive];
      if (!stepActive.isStepInvalid) {
        if (this.stepActive === this.steps.length) {
          this.stepActive = this.steps.length;
        } else {
          this.stepActive = this.stepActive + 1;
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    getProgressBar(indexItemStep) {
      if (indexItemStep >= 0 && this.stepActive > indexItemStep + 1) {
        return 100;
      } else {
        if (indexItemStep >= 0 && this.stepActive > indexItemStep) {
          return 50;
        } else {
          return 0;
        }
      }
    },
    validateActiveStep() {
      this.steps = this.steps.map((itemStep, indexItemStep) => {
        if (this.stepActive == itemStep.no) {
          if (
            this.$refs["stepper-content-" + indexItemStep] &&
            this.$refs["stepper-content-" + indexItemStep][0].$v
          ) {
            this.$refs["stepper-content-" + indexItemStep][0].$v.$touch();
            itemStep.isStepInvalid = this.$refs[
              "stepper-content-" + indexItemStep
            ][0].$v.$invalid;
          }
        }
        return itemStep;
      });
    },
    validateSteps() {
      this.steps = this.steps.map((itemStep, indexItemStep) => {
        if (
          this.$refs["stepper-content-" + indexItemStep] &&
          this.$refs["stepper-content-" + indexItemStep][0].$v
        ) {
          this.$refs["stepper-content-" + indexItemStep][0].$v.$touch();
          itemStep.isStepInvalid = this.$refs[
            "stepper-content-" + indexItemStep
          ][0].$v.$invalid;
        }
        return itemStep;
      });
    },
    cancelGlobalChanges() {
      this.modelo = JSON.parse(JSON.stringify(this.modeloBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
    getNegocioFromMetadata(id_negocio) {
      if (this.metadata.negocios) {
        let negocio_filtered = this.metadata.negocios.filter(
          itemNegocio => itemNegocio.id_negocio === id_negocio
        )[0];
        if (negocio_filtered) {
          return negocio_filtered;
        }
        return {};
      }
      return {};
    }
  },
  created() {
    if (this.$route.params.franquicia) {
      this.franquicia = this.serviceCommons.base64ToObject(
        this.$route.params.franquicia
      );
      this.modelo.id_franquicia = this.franquicia.id_franquicia;
      this.setModelo(this.modelo);
    }
    if (this.$route.params.modelo) {
      this.modelo = this.serviceCommons.base64ToObject(
        this.$route.params.modelo
      );
      this.getModelo();
    } else {
      this.getDataModelo();
    }
    this.initValues();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  }
};
</script>
